# Stack [ C ]

## **Usage**

Create a new stack objects for the type of data you whish to use
```c
  StackChar_s* stack_a = new_char_stack();
  StackU8_s stack_b = new_u8_stack();
  StackU16_s* stack_c = new_u16_stack();
  StackU32_s stack_d = new_u32_stack();
  StackFloat_s* stack_e = new_float_stack();
  StackI8_s stack_f = new_i8_stack();
  StackI16_s* stack_g = new_i16_stack();
  StackI32_s stack_h = new_i32_stack();
```

A node will only be created after a value has been pushed into the stack. The API has been simplified so that stack calls all the used the commands

```c
  //Push Value
  push(stack_a, 'c');
  push(stack_b, 42);

  //Pop Value
  val_x = pop(stack_c, 42);

  //Peek at top
  val_y = peek(stack_d, 42);

  //Delete Stack
  delete(stack_e);
```
---

## **Examples**

Comming soon..

---

## **Building New Stack Types**

The following are the blocks of code are needed to create a new stack type

**1. New stack node**

The stack is made up of dynamically allocated nodes that are linked in one direction, this means Node A can access Node B, but Node B has no way to connect to Node A

```mermaid
  graph LR
  Node_A --> Node_B --> Node_C
```

*stack.h*
```c
  struct NodeNAME_s* new_NAME_node(struct NodeNAME_s* next);

  static struct NodeNAME_s{
    struct NodeNAME_s* next;
    <type> val;
  }NodeNAME_s;
```

*stack.c*
```c
  struct NodeNAME_s* new_NAME_node(struct NodeNAME_s* next){
    struct NodeNAME_s* self = NULL;
    self =(struct NodeNAME_s*)malloc(sizeof(struct NodeNAME_s));
    
    //Ensure memory was allocated
    if(self == NULL){
      return NULL;
    }
    
    self->next = next;
    self->val = 0;
    return self;
  }
```

**2. New stack type**

*stack.h*
```c
  //Typedef at the top
  typedef struct StackNAME_s StackNAME_s;

  StackNAME_s* new_NAME_stack(void);

  struct StaclNAME_s{                                         
    struct NodeNAME_s* top;
    fptrDestroyStack_NAME_t delete;
    fptrPush_NAME_t push;  
    fptrPop_NAME_t pop;
    fptrPeek_NAME_t peek;
    fptrEmpty_NAME_t is_empty;
  };

```

*stack.c*
```c
  StackNAME_s* new_NAME_stack(void){
    StackNAME_s* self = NULL;
    self = (StackNAME_s*)malloc(sizeof(StackNAME_s));
    
    if(self == NULL){
      return NULL;
    }
  
    self->top = NULL;

    self->delete = &destroy_NAME_stack;
    self->push = &push_NAME;
    self->pop = &pop_NAME;
    self->peek = &peek_NAME;
    self->is_empty = &is_empty_NAME;
    return self;
}
```

**3. Push function**

*stack.h*
```c
  typedef void (*fptrPush_NAME_t)(StackNAME_s*, <type>);
  static void push_NAME(StackNAME_s* self, <type> val);
```

*stack.c*
```c
  void push_NAME(StackNAME_s* self, <type> val){
    self->top = new_NAME_node(self->top);
    self->top->val = val;
    return;
}
```

**4. Pop function**

*stack.h*
```c
  typedef <type> (*fptrPop_NAME_t)(StackNAME_s*);
  static <type> pop_NAME(StackNAME_s* self);
```

*stack.c*
```c
  char pop_NAME(StackNAME_s* self){
    if(is_empty_NAME(self) == true){
      return 0;
    }
    <type> temp_val;
    struct NodeNAME_s* temp_node;

    temp_val = self->top->val;
    temp_node = self->top->next;

    free(self->top);
    self->top = temp_node;
    
    return temp_val;
}
```
**5. Peek function**

*stack.h*
```c
  typedef <type> (*fptrPeek_NAME_t)(StackNAME_s*);
  static <type> peek_NAME(StackNAME_s* self);
```

*stack.c*
```c
  char peek_NAME(StackNAME_s* self){
    if(is_empty_NAME(self) == true){
      return 0;
    }
    return self->top->val;
  }
```

**6. Is Empty function**

*stack.h*
```c
  typedef bool (*fptrEmpty_NAME_t)(StackNAME_s*);
  static bool is_empty_NAME(StackNAME_s* self);
```

*stack.c*
```c
  bool is_empty_NAME(StackNAME_s* self){
    if(self->top == NULL){
      return true;
    }
    return false;
  }
```

**7. Destroy stack function**

*stack.h*
```c
  typedef void (*fptrDestroyStack_NAME_t)(StackNAME_s*); 
  static void destroy_NAME_stack(StackNAME_s* self);
```

*stack.c*
```c
void destroy_NAME_stack(StackNAME_s* self){
  while(self->top != NULL){
    pop(self);
  }

  free(self);

  return;
}
```

----

  ## Testing
  Unit testing is done using the [Ceedling](https://github.com/ThrowTheSwitch/Ceedling) build system. The testing source code is in the **test/** directory and can be run using the Ceedling test command from the top level
  ```bash
  ceedling test:all
  ```

[More info](https://libs2.gitlab.io/c/data-struct/stack/test.html)

### Requirments
+ Ceedling
+ Ruby
+ GCC

---

  ## Documentation
  The source code documentation is autogenerated using the [Doxygen](https://www.doxygen.nl/index.html) documentation generator. To generate the documentation Doxygen tool on the *Doxyfile* from the top level
  ```bash
  doxygen Doyfile
  ```

  This command will populate the **docs/** folder with a LaTeX folder and an HTML folder that will contain the appropriate files. The generated HTML documentation can be found at the following [link](https://libs2.gitlab.io/c/data-struct/stack/)
